
-module(hot).
-compile([export_all]).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% hot server example
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hgo() ->
    Pid = spawn(hot,server,[]),
    register(hs,Pid).  % hs hot server

server() -> receive
	       Msg ->
                  io:fwrite("Newer Msg Still: ~s~n", [Msg]),
                  hot:server()  % module:func for hot update when recompiled
            end.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% cold server example
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cgo() ->
    Pid = spawn(hot,cerver,[]),
    register(cs,Pid).  % cs cold server

cerver() -> receive
	       Msg ->
                  io:fwrite("Newer Msg Still: ~s~n", [Msg]),
                  cerver() % no code update when recompile the module
            end.   

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% what about state?
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

kgo() ->
    Pid = spawn(hot,kserver,[0]),
    register(ks,Pid).  % ks kounting hot server

kserver(N) -> receive
	       Msg ->
                  io:fwrite("New Msg: ~s, Acc: ~p~n", [Msg, N+1]),
                  hot:kserver(N+1)  % module:func for hot update when recompiled
              end.




